//
//  N80AppDelegate.m
//  N80
//
//  Created by Pecos on 2012/08/25.
//  Copyright (c) 2012年 H.Kanemoto. All rights reserved.
//

#import "N80AppDelegate.h"

@implementation N80AppDelegate
@synthesize n80glview;

- (void)dealloc
{
	[self.window release];
	[n80 release];
	[self.n80glview release];
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	// Insert code here to initialize your application
	// handling quit request from DOCK Icon
	NSAppleEventManager *appleEventManager = [NSAppleEventManager sharedAppleEventManager];
	[appleEventManager setEventHandler:self
						   andSelector:@selector(handleQuitAppleEvent:withReplyEvent:)
						 forEventClass:kCoreEventClass
							andEventID:kAEQuitApplication];
	
	// create and initialize N80 Emulator Object instance
	n80 = [[n80em alloc] init];
	n80ready = [n80 initEmulator:n80glview];
	if (!n80ready) {
		return;
	}
	n80glview.n80 = n80;
	
	/*[NSEvent addLocalMonitorForEventsMatchingMask:NSKeyDownMask
            handler:^(NSEvent* event) {
				//[n80 OnFlagsChanged:event];
				unichar ch = [[event characters] characterAtIndex:0];
				NSUInteger modifierFlags = [[NSApp currentEvent] modifierFlags];
				NSLog(@"KeyDown %d",ch);
				NSLog(@"LocalMonitor: %@", event);
				return event;
	}];
	[NSEvent addLocalMonitorForEventsMatchingMask:NSKeyUpMask
            handler:^(NSEvent* event) {
				//[n80 OnFlagsChanged:event];
				NSLog(@"LocalMonitor: %@", event);
				return event;
	}];*/
	
	// start emulator
	[n80 startEmulator];
}
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {
	if (n80 != nil) {
		NSLog(@"request close window");
		[n80 reqDispose];
	}
	NSLog(@"application terminated");
	return NSTerminateNow;
}
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication {
	return true;
}
- (void)handleQuitAppleEvent:(NSAppleEventDescriptor *)event withReplyEvent:(NSAppleEventDescriptor *)replyEvent {
	NSLog(@"request quit from dock icon");
	[NSApp terminate:self];
}
- (void)windowWillClose:(NSNotification *)notification {
	if (n80 != nil) {
		[n80 reqDispose];
	}
}
- (BOOL)windowShouldClose:(id)sender {
	NSLog(@"Window is closing");
	return true;
}
- (BOOL)validateMenuItem:(NSMenuItem *)menuItem {
	if ([[menuItem title] isEqualToString:NSLocalizedString(@"Load Image", @"イメージ読込")] == YES) {
		return n80ready;
	} else if ([[menuItem title] isEqualToString:NSLocalizedString(@"Reset", @"リセット")] == YES) {
		return n80ready;
	} else if ([[menuItem title] isEqualToString:NSLocalizedString(@"PCG", @"")] == YES) {
		return n80ready;
	} else if ([[menuItem title] isEqualToString:NSLocalizedString(@"Screen", @"画面切替")] == YES) {
		return n80ready;
	}
	return  [super validateMenuItem:menuItem];
}
- (IBAction)menuOpen:(id)sender {
	if (n80 != nil && !fullscreenOn) {
		[n80 reqOpenFile];
	}
}
- (IBAction)menuReset:(id)sender {
	if (n80 != nil) {
		[n80 reqReset];
	}
}
- (IBAction)menuPCG:(id)sender {
	if (n80 != nil) {
		[n80 reqPCGToggle];
	}
}

- (IBAction)menuScreen:(id)sender {
	// switch full/normal screen mode
    if (fullscreenOn == true) {
        [fullscreenWindow close];
        [self.window setAcceptsMouseMovedEvents:YES];
        [self.window setContentView: n80glview];
        [self.window makeKeyAndOrderFront: self];
        [self.window makeFirstResponder: n80glview];
        fullscreenOn = false;
    } else  {
        NSRect frame = [[NSScreen mainScreen] frame];
        // Instantiate new borderless window
        fullscreenWindow = [[NSWindow alloc]
                            initWithContentRect:frame
                            styleMask:NSBorderlessWindowMask
                            backing:NSBackingStoreBuffered
                            defer: NO];
        [self.window setAcceptsMouseMovedEvents:NO];
        if(fullscreenWindow != nil) {
            // Set the options for our new fullscreen window
            [fullscreenWindow setTitle: @"Full Screen"];
            [fullscreenWindow setReleasedWhenClosed: YES];
            [fullscreenWindow setAcceptsMouseMovedEvents:YES];
            [fullscreenWindow setContentView: n80glview];
            [fullscreenWindow makeKeyAndOrderFront:self ];
            // By setting the window level to just beneath the screensaver,
            // only this window will be visible (no menu bar or dock)
            [fullscreenWindow setLevel: NSScreenSaverWindowLevel-1];
            [fullscreenWindow makeFirstResponder:n80glview];
            fullscreenOn = true;
        } else {
            NSLog(@"Error: could not create fullscreen window!");
        }
    }
}
@end
