//
//  n80em.h
//  N80
//
//  Created by Pecos on 2012/08/22.
//  Copyright (c) 2012年 H.Kanemoto. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AudioUnit/AudioUnit.h>
#include "n80.h"
#include "pc-8001.h"
#include "libkern/OSAtomic.h"
/**--------------------------------------------------------------------------
 **	external variables/functions
 **------------------------------------------------------------------------*/
extern void		_n80_device_initialize(LPN80DEVICE, SYNCFNC enter, SYNCFNC leave, CMODFNC chgmod);
extern BYTE		_n80_mbread(USHORT Adr, DWORD *W);
extern void		_n80_mbwrite(USHORT Adr, BYTE v, DWORD *W);
extern BYTE		_n80_ioread(USHORT Port);
extern void		_n80_iowrite(USHORT Port, BYTE d);
extern void		__z80_set_external_method(LPZ80CPU cpu, LPZ80FNCMBR mbr, LPZ80FNCMBW mbw, LPZ80FNCIOR ior, LPZ80FNCIOW iow);
extern void		onkey_down(BYTE code);
extern void		onkey_up(BYTE code);
//-----------------------------------------------------------------------------
//	Sound data structures
//-----------------------------------------------------------------------------
#define MAXSTsARRAYS	(1000)
#define	WAVETOP			(4000)
#define WAVEBOTTOM		(-4000)

typedef struct _sound_ticks_tag {
	double		ticks;	// T-states累計
	DWORD		state;	// 0:off 1:on, PCGの場合はサンプル数(周波数)
}	SAMPLETs, *LPSAMPLETs;
typedef struct _sound_ticks_array_tag {
	SAMPLETs	arr[MAXSTsARRAYS];
	double		ticks_sum;
	int			count;
}	SAMPLETsARR, *LPSAMPLETsARR;
typedef struct _sound_bank_tag {
	SAMPLETs	current;
	SAMPLETsARR	banks[2];
	int			bank;
}	SAMPLETsBANK, *LPSAMPLETsBANK;
//-----------------------------------------------------------------------------
//	Emulator Class
//-----------------------------------------------------------------------------
@interface n80em : NSObject {
	@private
	LPDWORD 			bitmap;		// current bitmap buffer
	int					bitmapbank;
	LPDWORD				bitmap1;
	LPDWORD				bitmap2;
	CGContextRef		bmpctx;
	NSView				*view;
	BOOL				Z80running;
	BOOL				Disprunning;
	NSConditionLock		*joinZ80;
	NSConditionLock		*joinDisp;
	NSConditionLock		*pauseZ80sync;
	AudioUnit			gOutputUnit;
	BOOL				fnKey;
}
@property (assign) BOOL pause;

- (BOOL)initEmulator:(NSView *)myView;
- (void)startEmulator;
- (void)OnKeyDown:(NSEvent *) evt;
- (void)OnKeyUp:(NSEvent *) evt;
- (void)OnFlagsChanged: (NSEvent *) evt;
- (void)reqDispose;
- (void)reqReset;
- (void)reqPCGToggle;
- (void)reqOpenFile;
- (void)refleshScreen;
- (CGImageRef)reqImage;
- (void *)reqTexBitmap;
@end
